/***** tree.h *************************************
 * Description: 
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * Date: Wed Sep 12 10:35:29 2012
 **************************************************/
#ifndef TREE
#define TREE
#include "interface.h"

/* define tree node */
typedef struct node{
  struct node *left;
  struct node *right;
  struct node *parent;
  char *label;
  float dist;
  float bl;           /* branch length in  subtree */
  int id;
  int l;              /* number of leaves in subtree */
  float tau;
  float omega;
  float x;
  float y;
} Node;

Node *parseTree();
Node *newNode();
void printTree(Node *np);
Node *addNode(Node *parent, Node *child);
int deg(Node *np);
void countLeaves(Node *np);
void yyerror(const char *str);
#endif
